# -*- coding: utf-8 -*-
from __future__ import absolute_import, print_function

import random
import string
from .utils import get_path

lim_set = {"^", "$", "%", "&", "?", "~", "#", "-", "_", "<", ">"}
SRC1 = get_path("names.txt")
SRC2 = get_path("places.txt")


def read_words(words_file):
    return [word for line in open(words_file, "r") for word in line.split()]


class PasswordGenerator:
    def __init__(self, src1=SRC1, src2=SRC2):
        self.src1 = src1
        self.src2 = src2
        self.wordlist1 = read_words(src1)
        self.wordlist2 = read_words(src2)
        # print('wordlist1 length:', len(self.wordlist1))
        # print('wordlist2 length:', len(self.wordlist2))

    def generate_password(self):
        while True:
            password = (
                random.choice(self.wordlist1).lower()
                + random.choice(self.wordlist2).lower()
                + random.sample(lim_set, 1)[0]
                + random.choice(string.digits)
                + random.choice(string.digits)
            )
            if 12 < len(password) <= 20:
                return password
